//  Copyright 2011, Ian Hobson.
//
//  This file is part of gpsynth.
//
//  gpsynth is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  gpsynth is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with gpsynth in the file COPYING. 
//  If not, see http://www.gnu.org/licenses/.

// Graph Converter Interface

#pragma once

#include "synth_graph.hpp"

#include <string>

struct ConverterInterface {
  virtual std::string ToDOT(const sg::Graph& graph) = 0;
  virtual void Export(const sg::Graph& graph,
                      const std::string& export_folder,
                      const std::string& export_name) = 0;
};
