//  Copyright 2011, Ian Hobson.
//
//  This file is part of gpsynth.
//
//  gpsynth is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  gpsynth is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with gpsynth in the file COPYING. 
//  If not, see http://www.gnu.org/licenses/.

// Graph evaluator interface

#pragma once

#include "synth_graph.hpp"

#include <cstddef>
#include <string>
#include <vector>

// Used to listen to evaluator work thread notifications
struct EvaluatorListenerInterface {
  virtual void GraphRatedNotification(std::size_t graphs_rated) = 0;
};

struct EvaluatorInterface {
  virtual void RateGraphs(std::vector<sg::Graph>& graph) = 0;
  virtual void SetWorkFolder(const std::string& path) = 0;
  virtual void SetListener(EvaluatorListenerInterface* listener) = 0;
};
