//  Copyright 2011, Ian Hobson.
//
//  This file is part of gpsynth.
//
//  gpsynth is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  gpsynth is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with gpsynth in the file COPYING. 
//  If not, see http://www.gnu.org/licenses/.

// command line options handler

#pragma once

#include <string>

struct ProgramOptions {
  std::string target_path_;
  std::string grammar_path_;
  std::string sc_app_path_;
  std::string work_folder_;
  std::string fitness_features_;
  std::size_t population_size_;
  std::size_t generations_;
  std::size_t tournament_size_;
  double fitness_threshold_;
  double crossover_rate_;
  double mutation_rate_;
  bool reproduce_best_individual_;
  std::size_t analysis_window_size_;
  std::size_t analysis_hop_size_;
  std::size_t maximum_tree_depth_;
  bool keep_temp_folders_;
  std::size_t core_limit_;
};

void ParseCommandLine(int argument_count,
                      const char* arguments[],
                      ProgramOptions* options);
